'use strict'
Object.defineProperty(exports, '__esModule', { value: !0 }),
  require('reflect-metadata')
var e = require('tslib'),
  r = require('lodash.get'),
  t = require('lodash.set')
function a(e) {
  return e && 'object' == typeof e && 'default' in e ? e : { default: e }
}
var n,
  i = a(r),
  o = a(t)
function s(e) {
  var r = e.propName,
    t = e.propPath,
    a = e.propValue,
    n = e.json,
    i = e.serializableClass
  if (void 0 === a)
    throw new d({ json: n, propName: r, serializableClass: i, propPath: t })
}
function l(e) {
  return !!e && void 0 !== Reflect.getMetadata(n.TsJacksonSerializable, e)
}
!(function (e) {
  ;(e.TsJacksonJsonProperty = 'ts-jackson:jsonproperty'),
    (e.TsJacksonSerializable = 'ts-jackson:serializable'),
    (e.DesignType = 'design:type'),
    (e.DesignParamTypes = 'design:paramtypes')
})(n || (n = {}))
var u = (function (r) {
  function t(e) {
    var t = r.call(this) || this
    return (
      (t.name = 'SerializableError'),
      (t.message =
        e.name + ' class should annotated with @' + v.name + ' decorator'),
      t
    )
  }
  return e.__extends(t, r), t
})(Error)
function p(e) {
  if (!l(e)) throw new u(e)
}
function c(e) {
  var r = e.propName,
    t = e.propValue,
    a = e.validate,
    n = e.serializableClass
  if (!a(t))
    throw new y({
      propName: r,
      propValue: t,
      validate: a,
      serializableClass: n,
    })
}
var f,
  d = (function (r) {
    function t(e) {
      var t = e.propName,
        a = e.propPath,
        n = e.json,
        i =
          "Property '" +
          t +
          "' (path: '" +
          a +
          "') is required in " +
          e.serializableClass.name +
          ' but missing in provided JSON: ' +
          JSON.stringify(n, null, 2) +
          '.'
      return r.call(this, i) || this
    }
    return e.__extends(t, r), t
  })(Error),
  y = (function (r) {
    function t(e) {
      var a,
        n = e.propName,
        i = e.propValue,
        o = e.validate,
        s =
          "Property '" +
          n +
          "' with value " +
          i +
          ' in ' +
          e.serializableClass.name +
          ' failed to pass the validation check by ' +
          (o.name || 'anonymous function') +
          '.'
      return (
        (a = r.call(this, s) || this), Object.setPrototypeOf(a, t.prototype), a
      )
    }
    return e.__extends(t, r), t
  })(Error)
function v() {
  return function (e) {
    var r = { className: e.name }
    Reflect.defineMetadata(n.TsJacksonSerializable, r, e)
  }
}
function h(r, t) {
  for (var a = [], l = 2; l < arguments.length; l++) a[l - 2] = arguments[l]
  p(t)
  for (
    var u = Reflect.getMetadata(n.TsJacksonJsonProperty, t),
      f = new (t.bind.apply(t, e.__spreadArray([void 0], a)))(),
      d = 'string' == typeof r ? JSON.parse(r) : r,
      y = [],
      v = 0,
      h = Object.entries(u);
    v < h.length;
    v++
  ) {
    var b = h[v],
      z = b[0],
      g = b[1],
      S = g.paths
        ? g.paths.map(function (e) {
            return i.default(d, e)
          })
        : i.default(d, g.path)
    g.required &&
      s({
        json: d,
        propName: z,
        propValue: S,
        serializableClass: t,
        propPath: g.path,
      })
    var N = g.deserialize ? g.deserialize(S) : m(S, g.type, g.elementType)
    g.validate &&
      c({
        propName: z,
        propValue: N,
        validate: g.validate,
        serializableClass: t,
      }),
      void 0 !== N && o.default(f, z, N),
      g.afterDeserialize &&
        y.push({
          propName: z,
          deserializedValue: N,
          afterDeserialize: g.afterDeserialize,
        })
  }
  return (
    y.forEach(function (e) {
      var r = e.propName,
        t = e.deserializedValue,
        a = e.afterDeserialize
      o.default(f, r, a(f, t))
    }),
    f
  )
}
function m(e, r, t) {
  if (null == e || void 0 === r) return e
  if (Array.isArray(r))
    return r.map(function (r, t) {
      return m(e[t], r)
    })
  if ('function' == typeof r)
    switch (null == r ? void 0 : r.name) {
      case f.Date:
        return new Date(e)
      case f.Array:
        return e.map(function (e) {
          return l(t) ? h(e, t) : e
        })
      case f.Set:
        var a = e.map(function (e) {
          return l(t) ? h(e, t) : e
        })
        return new Set(a)
      case f.Boolean:
        return Boolean(e)
      case f.Number:
        return Number(e)
      case f.String:
        return e.toString()
      default:
        return l(r) ? h(e, r) : e
    }
}
function b(e) {
  p(e.constructor)
  for (
    var r = Reflect.getMetadata(n.TsJacksonJsonProperty, e.constructor),
      t = {},
      a = function (r, a) {
        var n = void 0,
          i = void 0
        a.beforeSerialize
          ? (i = (n = a.beforeSerialize(e[r])).constructor)
          : ((n = e[r]), (i = a.type))
        var s = a.serialize ? a.serialize(n) : z(n, i)
        a.paths
          ? a.paths.forEach(function (e, r) {
              o.default(t, e, s[r])
            })
          : o.default(t, a.path, s)
      },
      i = 0,
      s = Object.entries(r);
    i < s.length;
    i++
  ) {
    var l = s[i]
    a(l[0], l[1])
  }
  return t
}
function z(e, r) {
  if (void 0 === e) return e
  if (Array.isArray(r))
    return r.map(function (r, t) {
      return z(e[t], r)
    })
  if ('function' == typeof r)
    switch (null == r ? void 0 : r.name) {
      case f.Set:
      case f.Array:
        return Array.from(e.values()).map(function (e) {
          return l(e.constructor) ? b(e) : e
        })
      default:
        return l(r) ? b(e) : e
    }
}
!(function (e) {
  ;(e.Array = 'Array'),
    (e.Set = 'Set'),
    (e.Boolean = 'Boolean'),
    (e.Date = 'Date'),
    (e.Number = 'Number'),
    (e.Object = 'Object'),
    (e.String = 'String')
})(f || (f = {}))
var g = (function () {
  function r() {}
  return (
    (r.prototype.stringify = function () {
      return JSON.stringify(this.serialize())
    }),
    (r.prototype.serialize = function () {
      return b(this)
    }),
    (r.deserialize = function (r) {
      for (var t = [], a = 1; a < arguments.length; a++) t[a - 1] = arguments[a]
      return h.apply(void 0, e.__spreadArray([r, this], t))
    }),
    (r = e.__decorate([v()], r))
  )
})()
;(exports.JsonProperty = function (r) {
  return (
    void 0 === r && (r = {}),
    function (t, a) {
      var i =
          'string' == typeof r
            ? { path: r }
            : Array.isArray(r)
            ? { paths: r }
            : r,
        o = e.__assign(e.__assign({ name: a, path: i.path || a }, i), {
          type: i.type || Reflect.getMetadata('design:type', t, a),
        }),
        s = Reflect.getMetadata(n.TsJacksonJsonProperty, t.constructor) || {}
      ;(s[a] = o),
        Reflect.defineMetadata(n.TsJacksonJsonProperty, s, t.constructor)
    }
  )
}),
  (exports.Serializable = v),
  (exports.SerializableEntity = g),
  (exports.deserialize = h),
  (exports.serialize = b)
//# sourceMappingURL=index.cjs.js.map
