import 'reflect-metadata'
import {
  __extends as e,
  __spreadArray as r,
  __assign as t,
  __decorate as a,
} from 'tslib'
import n from 'lodash.get'
import i from 'lodash.set'
function o(e) {
  var r = e.propName,
    t = e.propPath,
    a = e.propValue,
    n = e.json,
    i = e.serializableClass
  if (void 0 === a)
    throw new d({ json: n, propName: r, serializableClass: i, propPath: t })
}
var s
function l(e) {
  return !!e && void 0 !== Reflect.getMetadata(s.TsJacksonSerializable, e)
}
!(function (e) {
  ;(e.TsJacksonJsonProperty = 'ts-jackson:jsonproperty'),
    (e.TsJacksonSerializable = 'ts-jackson:serializable'),
    (e.DesignType = 'design:type'),
    (e.DesignParamTypes = 'design:paramtypes')
})(s || (s = {}))
var u = (function (r) {
  function t(e) {
    var t = r.call(this) || this
    return (
      (t.name = 'SerializableError'),
      (t.message =
        e.name + ' class should annotated with @' + h.name + ' decorator'),
      t
    )
  }
  return e(t, r), t
})(Error)
function p(e) {
  if (!l(e)) throw new u(e)
}
function c(e) {
  var r = e.propName,
    t = e.propValue,
    a = e.validate,
    n = e.serializableClass
  if (!a(t))
    throw new m({
      propName: r,
      propValue: t,
      validate: a,
      serializableClass: n,
    })
}
var f,
  d = (function (r) {
    function t(e) {
      var t = e.propName,
        a = e.propPath,
        n = e.json,
        i =
          "Property '" +
          t +
          "' (path: '" +
          a +
          "') is required in " +
          e.serializableClass.name +
          ' but missing in provided JSON: ' +
          JSON.stringify(n, null, 2) +
          '.'
      return r.call(this, i) || this
    }
    return e(t, r), t
  })(Error),
  m = (function (r) {
    function t(e) {
      var a,
        n = e.propName,
        i = e.propValue,
        o = e.validate,
        s =
          "Property '" +
          n +
          "' with value " +
          i +
          ' in ' +
          e.serializableClass.name +
          ' failed to pass the validation check by ' +
          (o.name || 'anonymous function') +
          '.'
      return (
        (a = r.call(this, s) || this), Object.setPrototypeOf(a, t.prototype), a
      )
    }
    return e(t, r), t
  })(Error)
function h() {
  return function (e) {
    var r = { className: e.name }
    Reflect.defineMetadata(s.TsJacksonSerializable, r, e)
  }
}
function v(e, t) {
  for (var a = [], l = 2; l < arguments.length; l++) a[l - 2] = arguments[l]
  p(t)
  for (
    var u = Reflect.getMetadata(s.TsJacksonJsonProperty, t),
      f = new (t.bind.apply(t, r([void 0], a)))(),
      d = 'string' == typeof e ? JSON.parse(e) : e,
      m = [],
      h = 0,
      v = Object.entries(u);
    h < v.length;
    h++
  ) {
    var b = v[h],
      z = b[0],
      g = b[1],
      N = g.paths
        ? g.paths.map(function (e) {
            return n(d, e)
          })
        : n(d, g.path)
    g.required &&
      o({
        json: d,
        propName: z,
        propValue: N,
        serializableClass: t,
        propPath: g.path,
      })
    var S = g.deserialize ? g.deserialize(N) : y(N, g.type, g.elementType)
    g.validate &&
      c({
        propName: z,
        propValue: S,
        validate: g.validate,
        serializableClass: t,
      }),
      void 0 !== S && i(f, z, S),
      g.afterDeserialize &&
        m.push({
          propName: z,
          deserializedValue: S,
          afterDeserialize: g.afterDeserialize,
        })
  }
  return (
    m.forEach(function (e) {
      var r = e.propName,
        t = e.deserializedValue,
        a = e.afterDeserialize
      i(f, r, a(f, t))
    }),
    f
  )
}
function y(e, r, t) {
  if (null == e || void 0 === r) return e
  if (Array.isArray(r))
    return r.map(function (r, t) {
      return y(e[t], r)
    })
  if ('function' == typeof r)
    switch (null == r ? void 0 : r.name) {
      case f.Date:
        return new Date(e)
      case f.Array:
        return e.map(function (e) {
          return l(t) ? v(e, t) : e
        })
      case f.Set:
        var a = e.map(function (e) {
          return l(t) ? v(e, t) : e
        })
        return new Set(a)
      case f.Boolean:
        return Boolean(e)
      case f.Number:
        return Number(e)
      case f.String:
        return e.toString()
      default:
        return l(r) ? v(e, r) : e
    }
}
function b(e) {
  p(e.constructor)
  for (
    var r = Reflect.getMetadata(s.TsJacksonJsonProperty, e.constructor),
      t = {},
      a = function (r, a) {
        var n = void 0,
          o = void 0
        a.beforeSerialize
          ? (o = (n = a.beforeSerialize(e[r])).constructor)
          : ((n = e[r]), (o = a.type))
        var s = a.serialize ? a.serialize(n) : z(n, o)
        a.paths
          ? a.paths.forEach(function (e, r) {
              i(t, e, s[r])
            })
          : i(t, a.path, s)
      },
      n = 0,
      o = Object.entries(r);
    n < o.length;
    n++
  ) {
    var l = o[n]
    a(l[0], l[1])
  }
  return t
}
function z(e, r) {
  if (void 0 === e) return e
  if (Array.isArray(r))
    return r.map(function (r, t) {
      return z(e[t], r)
    })
  if ('function' == typeof r)
    switch (null == r ? void 0 : r.name) {
      case f.Set:
      case f.Array:
        return Array.from(e.values()).map(function (e) {
          return l(e.constructor) ? b(e) : e
        })
      default:
        return l(r) ? b(e) : e
    }
}
function g(e) {
  return (
    void 0 === e && (e = {}),
    function (r, a) {
      var n =
          'string' == typeof e
            ? { path: e }
            : Array.isArray(e)
            ? { paths: e }
            : e,
        i = t(t({ name: a, path: n.path || a }, n), {
          type: n.type || Reflect.getMetadata('design:type', r, a),
        }),
        o = Reflect.getMetadata(s.TsJacksonJsonProperty, r.constructor) || {}
      ;(o[a] = i),
        Reflect.defineMetadata(s.TsJacksonJsonProperty, o, r.constructor)
    }
  )
}
!(function (e) {
  ;(e.Array = 'Array'),
    (e.Set = 'Set'),
    (e.Boolean = 'Boolean'),
    (e.Date = 'Date'),
    (e.Number = 'Number'),
    (e.Object = 'Object'),
    (e.String = 'String')
})(f || (f = {}))
var N = (function () {
  function e() {}
  return (
    (e.prototype.stringify = function () {
      return JSON.stringify(this.serialize())
    }),
    (e.prototype.serialize = function () {
      return b(this)
    }),
    (e.deserialize = function (e) {
      for (var t = [], a = 1; a < arguments.length; a++) t[a - 1] = arguments[a]
      return v.apply(void 0, r([e, this], t))
    }),
    (e = a([h()], e))
  )
})()
export {
  g as JsonProperty,
  h as Serializable,
  N as SerializableEntity,
  v as deserialize,
  b as serialize,
}
//# sourceMappingURL=index.esm.js.map
